##
##  qq.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
%define       V_qq_base  0.2.4
%define       V_qq_snap  20250117

#   package information
Name:         qq
Summary:      Configuration File Query Tool
URL:          https://github.com/JFryy/qq
Vendor:       FFry
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Text
License:      MIT
Version:      %{V_qq_base}.%{V_qq_snap}
Release:      20250117

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/qq/qq-%{V_qq_snap}.tar.xz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, go
PreReq:       OpenPKG, openpkg >= 20160101

%description
    qq(1) is a interoperable configuration format transcoder with jq(1)
    query syntax. qq(1) is multi modal, and can be used as a replacement
    for jq(1) or be interacted with via a repl with autocomplete and
    realtime rendering preview for building queries.

%track
    prog qq:base = {
        version   = %{V_qq_base}
        url       = https://github.com/JFryy/qq/releases
        regex     = tree/v(\d+\.\d+\.\d+)
    }
    prog qq:snap = {
        version   = %{V_qq_snap}
        url       = http://download.openpkg.org/components/versioned/qq/
        regex     = qq-(__VER__)\.tar\.xz
    }

%prep
    %setup -q -n qq

%build
    #   build program
    export GOPATH=`pwd`
    cd $GOPATH/src/github.com/JFryy/qq
    go build -v -o qq .

%install
    #   create directory hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin

    #   install program
    %{l_shtool} install -c -s -m 755 \
        src/github.com/JFryy/qq/qq \
        $RPM_BUILD_ROOT%{l_prefix}/bin/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

